package dybip;
import java.util.ArrayList;

/**
 * This class represents An ArrayList of Dybip  objects. This class is super class of other list classes defined in the package. It defines the basic methods  
 * @author el-ballouli
 * @param <T>
 */
public class DyBIPArrayList<T> extends DyBIPObject {
	private ArrayList<T> arrayList;
	
	/**
	 * Constructs an array list of type T having the size specified in the parameter.
	 * @param size
	 */
	public DyBIPArrayList(int size){
		arrayList = new ArrayList<T>(size);
	}
	/**
	 * Constructs an empty array list of type T and size zero.
	 */
	public DyBIPArrayList(){
		arrayList = new ArrayList<T>();
	}
	/**
	 * This method adds element of type T to the list. Accordingly if the list is full, its size is increased before the addition of the new element.
	 * @param elem
	 */
	public void add(T elem){
		arrayList.add(elem);
	}
	public void remove(int index) {
		arrayList.remove(index);
	}
	public void remove(T object) {
		arrayList.remove(object);
	}
	public int indexOf(T Object) {
		return arrayList.indexOf(Object);
	}
	public ArrayList<T> getArrayList(){
		return arrayList;
	}
	/**
	 * 
	 * @param elems
	 */
	public void add(DyBIPArrayList<T> elems){
		for(int i = 0; i < elems.size(); i++)
			arrayList.add(elems.get(i));
	}
	/**
	 * This methods adds all elements in another arraylist of type T to the existing list.
	 * @param arrayList
	 */
	public void setList(ArrayList<T> arrayList){
		this.arrayList =  arrayList;
	}
	/**
	 * returns the size of the array list regardless of the actual count of objects in the list.
	 * @return returns the size of the array list.
	 */
	public int size(){
		return arrayList.size();
	}
	/**
	 * Returns the array list of type T.
	 * @return
	 */
	public ArrayList<T> getList(){
		return arrayList;
	}
	/**
	 * This methods deletes all elements in the array list
	 */
	public void clear(){
		arrayList.clear();
	}
	/**
	 * This method returns an element of type T whose index matches the index specified in the method parameter.
	 * @param index
	 * @return returns the element whose index matches the index specified in the method parameter.
	 */
	public T get(int index){
		return arrayList.get(index); 
	}
	/**
	 * This method return 
	 * @param elem
	 * @return
	 */
	public boolean contains(T elem){
		return arrayList.contains(elem);
	}

	/**
	 * 
	 */
	@Override
	public String toString(){
		if(arrayList.size() == 0)
			return "";
		String result = "";
		for(int i = 0 ; i < arrayList.size(); i++)
			if(i == 0)
				result += arrayList.get(i).toString();
			else
				result += ", " + arrayList.get(i).toString();
		
		return result;
	}
	
	@Override
	public String toString(int toStringMode){
		return "";
	}
}
