package dybip;

import dybip.InteractionStmt.ForEachIterator;
import dybip.InteractionStmt.InterReconfigurationRuleStmt;
import dybip.InteractionStmt.RuleStmt;
import dybip.InteractionStmt.Iterator;
import dybip.InteractionStmt.NestedIterators;
import dybip.InteractionStmt.InteractionRuleStmt;
import dybip.InteractionStmt.ReconfigurationRuleStmt;
import dybip.componentType.PortSymbolMap;
import dybip.expression.Expression;
import dybip.expression.action.ActionExpression;
import dybip.expression.action.Assignment;
import dybip.expression.booleanExpr.BooleanExpression;
import dybip.expression.list.ActionList;
import dybip.expression.list.DataList;
import dybip.expression.list.GuardList;
import dybip.expression.literal.LiteralExpression;
import dybip.expression.variable.Index;
import dybip.expression.variable.PortAccess;
import dybip.expression.variable.VariableExpression;
import dybip.systemStmt.SystemStmt;
import dybip.systemStmt.componentTypeStmt.ComponentTypeStmt;
import dybip.systemStmt.componentTypeStmt.DataTypeStmtList;
import dybip.systemStmt.componentTypeStmt.InitTransitionStmt;
import dybip.systemStmt.componentTypeStmt.PortStmtList;
import dybip.systemStmt.componentTypeStmt.TransitionStmt;
import dybip.systemStmt.motifInstanceStmt.MotifInstanceStmtList;
import dybip.systemStmt.motifTypeStmt.ComponentInstanceStmt;
import dybip.systemStmt.motifTypeStmt.ComponentInstanceStmtList;
import dybip.systemStmt.motifTypeStmt.MotifTypeStmt;
import dybip.systemStmt.motifTypeStmt.ReferStmt;
import dybip.systemStmt.motifTypeStmt.ReferStmtList;

/**
 * This class is the super class of all other classes in a dybip package, it defines the general behaviour and common methods to all objects in a dybip system
 * @author el-ballouli
 *
 */
public class DyBIPObject {

	/**
	 * @inheritDoc
	 */
	@Override
	public String toString(){
		return this.toString(DyBIPRunner.NORMAL);
	}
	/**
	 * 
	 * @param toStringMode
	 * @return
	 */
	public String toString(int toStringMode)
	{
		return this.toString(toStringMode);
	}
//	public Class<?> getClassType(Context context){
//		return this.getClassType(context);
//	}
	public BooleanExpression asBooleanExpression(){
		return (BooleanExpression) this;
	}

	//---------------------  Iterators
	public Iterator asIterator(){
		return (Iterator) this;
	}
	public NestedIterators asNestedIterators(){
		return (NestedIterators) this;
	}
	public SystemStmt asSystem(){
		return (dybip.systemStmt.SystemStmt) this;
	}
	public ActionList asActionList(){
		return (ActionList) this;
	}
	public GuardList asGuardList(){
		return (GuardList) this;
	}
	public GuardActionPair asGuardActionPair(){
		return (GuardActionPair) this;
	}
	public Expression asExpression(){
		return (Expression) this;
	}
	public Index asIndex() {
		return (Index) this;
	}
	public Assignment asAssignment(){
		return (Assignment) this;
	}
	public LiteralExpression asExprLiteral(){
		return (LiteralExpression) this;
	}
	public VariableExpression asExprVariable(){
		return (VariableExpression) this;
	}
	public ActionExpression asActionExpression(){
		return (ActionExpression) this;
	}
	public DataList asDataList(){
		return (DataList) this;
	}
	public ReferStmt asReferStmt(){
		return (ReferStmt) this;
	}
	public MotifTypeStmt asMotifType(){
		return (MotifTypeStmt) this;
	}
	public ComponentInstanceStmt asComponentInstanceStmt(){
		return (ComponentInstanceStmt) this;
	}
	public PortSymbolMap asPortSymbolMap(){
		return (PortSymbolMap) this;
	}
	public RuleStmt asInteractionStmt(){
		return (RuleStmt) this;
	}
	public PortAccess asPortAccess(){
		return (PortAccess) this;
	}
	public ReconfigurationRuleStmt asSystemInteractionStmt(){
		return (ReconfigurationRuleStmt) this;
	}
	public ForEachIterator asSystemIterator(){
		return (ForEachIterator) this;
	}
	//// -------- Component Type Stmt 
	public ComponentTypeStmt asComponentTypeStmt(){
		return (ComponentTypeStmt) this;
	}
	public PortStmtList asPortStmtList(){
		return (PortStmtList) this;
	}
	public DataTypeStmtList asDataTypeStmtList(){
		return (DataTypeStmtList) this;
	}
	public InitTransitionStmt asInitTransitionStmt(){
		return (InitTransitionStmt) this;
	}
	public TransitionStmt asTransitionStmt(){
		return (TransitionStmt) this;
	}
	
	public MotifInstanceStmtList asMotifInstanceStmtList(){
		return (MotifInstanceStmtList) this;
	}
	public MotifTypeStmt asMotifTypeStmt(){
		return (MotifTypeStmt) this;
	}
	public ReferStmtList asReferStmtList(){
		return (ReferStmtList) this;
	}
	public InterReconfigurationRuleStmt asInterReconfigurationRuleStmt() {
		return (InterReconfigurationRuleStmt) this;
	}
	public ReconfigurationRuleStmt asReconfigurationRuleStmt(){
		return (ReconfigurationRuleStmt) this;
	}
	public InteractionRuleStmt asInteractionRuleStmt(){
		return (InteractionRuleStmt) this;
	}
	public ComponentInstanceStmtList asComponentInstanceStmtList(){
		return (ComponentInstanceStmtList) this;
	}

}
