package dybip;

import java.util.Iterator;

import dybip.expression.variable.Index;

public class IndexMap extends DyBIPHashMap<String, Index> {
	
	
	public void put(String varName, int value){
		put(varName, new Index(varName, value));
	}
	public void put(Index index){
		put(index.getName(), index);
	}
	@Override
	public String toString(){
		String str = "{";
		
		Iterator<String> itr = keySet().iterator();
		if(itr.hasNext()){
			str += get(itr.next()).toString();
			while(itr.hasNext()){
				String key = itr.next();
				str += ", " + get(key).toString() ;
			}
		}
		return str + "}";
	}
	@Override
	public String toString(int toStringMode){
		String str = "{";
	
		Iterator<String> itr = keySet().iterator();
		if(itr.hasNext()){
			str += get(itr.next()).toString(toStringMode);
			while(itr.hasNext()){
				String key = itr.next();
				str += ", " + get(key).toString(toStringMode) ;
			}
		}
		return str + "}";
	}
}
