package dybip.InteractionStmt;

import dybip.Context;
import dybip.IndexMap;
import dybip.componentInstance.ComponentInstance;
import dybip.expression.list.ActionList;

public class EnabledInteraction extends EnabledStep{

	private InteractingComponentList interactingComponentList;
	
	public EnabledInteraction(int size) {
		interactingComponentList = new InteractingComponentList(size);
	}
	public EnabledInteraction(ActionList updateExpr, IndexMap indexMap) {
		this();
		setActionList(updateExpr);
		setIndexMap(indexMap);
	}
	public EnabledInteraction() {
		interactingComponentList = new InteractingComponentList();
	}
	public int size(){
		return interactingComponentList.size();
	}
	public void add(InteractingComponent ic){
		interactingComponentList.add(ic);
	}
	public InteractingComponent get(int index){
		return interactingComponentList.get(index);
	}
	public InteractingComponentList getInteractingComponentList(){
		return interactingComponentList;
	}
	@Override 
	public void execute(Context context){
		// TODO create a deep copy of context 
		// TODO make sure all actions are successfull before updating context
		context.setIndexMap(getIndexMap());
		for(int i = 0; i < interactingComponentList.size(); i++){
			InteractingComponent temp = interactingComponentList.get(i);
			String portName = temp.getParticipatingPort();
			ComponentInstance instance = temp.getComponentInstance();
			
			Boolean successComponentAction = instance.makeTransition(portName, context);
				if(!successComponentAction);
					// TODO retract all updates made 
					// TODO all components move or none
				
		}
		Boolean SuccessInteractionAction =  getActionList().minify(context).value(Boolean.class);
		if(!SuccessInteractionAction);
		// TODO retract all updates
		context.resetIndexMap();
	}
	public String toMinifyString(Context context) {
		String str = "";
		context.setIndexMap(getIndexMap());
		for(int i = 0; i< interactingComponentList.size(); i++)
				str += "\t\t" + interactingComponentList.get(i).toMinifyString(context) + "\n";
		context.resetIndexMap();
		return str;
	}
	@Override 
	public String toString(int toStringMode){
		String str = "";
		for(int i = 0; i< interactingComponentList.size(); i++)
				str += "\t\t" + interactingComponentList.get(i).toString(toStringMode) + "\n";
		return str;
	}
}
