package dybip.InteractionStmt;

import dybip.Context;
import dybip.DyBIPArrayList;

public class EnabledStepList<T extends EnabledStep> extends DyBIPArrayList<T>{

	@Override
	public boolean contains(T enabledStep) {
		for(int i = 0; i < size(); i++) {
			if(get(i).getIndexMap() == enabledStep.getIndexMap())
				return true;
		}
		return false;
	}
	@Override 
	public String toString(){
		String str = "\tEnabled Steps:\n";
		for(int i = 0; i < size(); i++){
			str += "\tStep " + i + "\n" + get(i).toString();
		}
		return str;
	}
	public String toMinifyString(Context context) {
		String str = "\tEnabled Steps:\n";
		for(int i = 0; i < size(); i++){
			str += "\tStep " + i + "\n" + get(i).toMinifyString(context);
		}
		return str;
	}
	public void execute(Context context, int index) {
		get(index).execute(context);
	}
}
