package dybip.InteractionStmt;

import dybip.Context;
import dybip.DyBIPArrayList;

public class ExecutableInterReconfigurationRuleList extends DyBIPArrayList<ExecutableInterReconfigurationRule>{

	public ExecutableInterReconfigurationRuleList(int size){
		super(size);
	}
	public ExecutableInterReconfigurationRuleList(){
		super();
	}
	public ExecutableInterReconfigurationRuleList(InterReconfigurationRuleStmtList stmtList, Context context) {
		super(stmtList.size());
		for(int i = 0; i < stmtList.size(); i++) {
			add(new ExecutableInterReconfigurationRule(stmtList.get(i), context));
		}
	}
	public boolean hasEnabledSteps() {
		for(int i = 0; i < size(); i++)
			if(get(i).hasEnabledStep()) return true;
		return false;
				
	}
	@Override
	public String toString(){
		String str = "\t\t\tINTER RECONFIGURATION RULES:\n";
		if(size() == 0)
			return str + "\t\t\tempty";
		for(int i = 0; i < size(); i++)
			str += "\t\t\tRULE " + i + ":\n" + get(i).toString() + "\n";
		return str;
	}
}
