package dybip.InteractionStmt;

import dybip.Context;
import dybip.DyBIPObject;
import dybip.componentInstance.ComponentInstance;
import dybip.motifInstance.Group;


public class InteractingComponent extends DyBIPObject{
	private ComponentInstance componentInstance;
	private Group groupPtr;
	private String participatingPort;
	
	public InteractingComponent(ComponentInstance instance, Group groupPtr, String participatingPort) {
		this.componentInstance = instance;
		this.groupPtr = groupPtr;
		this.participatingPort = participatingPort;
	}
	public String getParticipatingPort(){
		return participatingPort;
	}
	public ComponentInstance getComponentInstance() {
		return componentInstance;
	}
	@Override
	public String toString(int toStringMode){ 
		String str = "";
			str = groupPtr.getName()+ "[" + groupPtr.indexOf(componentInstance)  + "]." + participatingPort;
		return str;
	}
	public String toMinifyString(Context context) {
		return toString();
	}
	@Override 
	public boolean equals(Object obj){
		InteractingComponent  ic = (InteractingComponent)obj;
		return (componentInstance == ic.getComponentInstance() && ic.getParticipatingPort().equals(participatingPort));
	}
	
}
