package dybip.InteractionStmt;

import dybip.GuardActionPair;
import dybip.componentType.PortSymbolMap;
import dybip.expression.list.PortReferenceList;
import dybip.systemStmt.motifTypeStmt.PortSymbolList;

public class InteractionRuleStmt extends RuleStmt{
	private PortSymbolMap portMap;
	private PortSymbolList portSymbolList;
	
	public InteractionRuleStmt(PortSymbolList portList, PortSymbolMap portMap, GuardActionPair guardAction, NestedIterators nestedIterators){
		super(nestedIterators, guardAction);
		this.portSymbolList = portList;
		this.portMap = portMap;
	}
	
	public PortReferenceList getPortList(){
		PortReferenceList list = new PortReferenceList();
		for(String key: portMap.keySet())
			list.add(portMap.get(key));
		return list;
	}
	@Override
	public String toString(){
		String str = "";
		if(getNestedIterators() != null)
			str += getNestedIterators().toString();
		
		str +=  "\tinteraction " + portSymbolList.toString() + "\n\t\t";
		str += portMap.toString() + "\n\t\t";
		str += getGuardAction().toString() + "\n";
		
		return str;
	}
}
