package dybip.componentInstance;

import dybip.expression.Expression;
import dybip.expression.literal.BooleanLiteral;
import dybip.Context;

public class BooleanData extends Data{
	BooleanLiteral  bool;
	public BooleanData(String varName){
		super(varName);
		bool = new BooleanLiteral(true);
		
	}
	public BooleanLiteral  getBoolean(){
		return bool;
	}
	@Override 
	public String getTrace() {
		return "var boolean REPLACE1.REPLACE2." + getName() + " " + value(Boolean.class);
	}
	@Override 
	public void resetData(){
		bool = null;
	}
	@Override
	public void setData(Expression data){
		bool = (BooleanLiteral) data;
	}
	@Override
	public Expression minify(Context context) {
		return bool.minify(context);
	}
	@Override
	public Class<?> getExpressionType(Context context) {
		return Boolean.class;
	}
	@Override
	public  <T> T  value( Class<T> type){
		return bool.value(type);
	}
	@Override
	public String toString(){
		if(bool != null)
			return  bool.toString();
		else
			return  "null";
	}
	@Override
	public String toString(int toStringMode){
		return toString();
	}
}
