package dybip.componentInstance;

import java.util.Iterator;
import dybip.DyBIPHashMap;
import dybip.DyBIPRunner;


public class DataMap extends DyBIPHashMap<String, Data>{

	public DataMap(int size){
		super(size);
	}
	public DataMap(){
		super();
	}
	public void put(Data d){
		put(d.getName(), d);
	}

	public String getTrace() {
		String str ="";
		for(String varName: keySet()) {
			str += get(varName).getTrace() + "\n";
		}
		return str;
	}
	@Override
	public String toString(int toStringMode){
		String str = "";
		if(toStringMode == DyBIPRunner.DEBUG)
			str += "{";

		Iterator<String> itr = keySet().iterator();

		if(itr.hasNext()){
			String key = itr.next();
			Data d = get(key);
			if(d != null)
				str += key + "=" + d.toString(toStringMode);

			while(itr.hasNext()){
				key = itr.next();
				d = get(key);
				if(d != null)
					str += ", " + key + "=" + d.toString(toStringMode) ;
			}
		}
		if (toStringMode == DyBIPRunner.DEBUG)
			str += "}";
		return str;
	}
}
