package dybip.componentInstance;

import dybip.expression.Expression;
import dybip.expression.literal.IntegerLiteral;
import dybip.Context;

public class IntegerData extends Data{
	IntegerLiteral  x;
	public IntegerData(String varName){
		super(varName);
		x = new IntegerLiteral(0);
	}
	public IntegerLiteral getInteger(){
		return x;
	}
	@Override 
	public String getTrace() {
		return "var int REPLACE1.REPLACE2." + getName() + " " + value(Integer.class);
	}
	@Override 
	public void resetData(){
		x = null;
	}
	@Override
	public void setData(Expression data){
		x = (IntegerLiteral) data;
	}
	@Override
	public Expression minify(Context context) {
		return x.minify(context);
	}
	@Override
	public  <T> T  value( Class<T> type){
		return x.value(type);
	}
	@Override
	public Class<?> getExpressionType(Context context) {
		return Integer.class;
	}
	@Override
	public String toString(){
		if(x == null)
			return "null";
		return x.toString();
	}
	@Override
	public String toString(int toStringMode){
		return toString();
	}
	
}
