package dybip.componentType;

import java.util.Set;
import dybip.DyBIPHashMap;
import dybip.systemStmt.componentTypeStmt.ComponentTypeStmt;
import dybip.systemStmt.componentTypeStmt.ComponentTypeStmtList;
/**
 * This class represents a Hashmap of component type with their corresponding names
 * component type names are used as key values in the hashMap
 * @author el-ballouli
 *
 */
public class ComponentTypeMap extends DyBIPHashMap<String, ComponentType> {

	public ComponentTypeMap(int size){
		super(size);
	}
	public ComponentTypeMap(ComponentTypeStmtList stmtList){
		super(stmtList.size());
		for(int i = 0; i < stmtList.size(); i++){
			ComponentTypeStmt stmt = stmtList.get(i);
			String name = stmt.getName();
			DataTypeList data = new DataTypeList(stmt.getDataTypeStmtList());
			InitTransition initTrans = new InitTransition(stmt.getInitTransition());
			TransitionMap transitionMap = new TransitionMap(stmt.getTransitions());
			
			DynamicComponentTypeGenerator.generate(stmt.getName());
			ComponentType ctype = DynamicComponentTypeGenerator.createComponentType(name, data, initTrans, transitionMap);
			put(ctype);
		}
	}
	public void put(ComponentType ct){
		put(ct.getName(), ct);
	}
	public String toString()
	{
		String result = "";
		Set<String> cTypesName = keySet();
		for(String s : cTypesName)
			result += "\t\t" + get(s).toString() + "\n";
		return result;
	}
	public String toString(int toStringMode){
		String result = "";
		return result;
	}
}
