package dybip.componentType;

import dybip.DyBIPObject;
import dybip.GuardActionPair;
import dybip.expression.list.ActionList;
import dybip.expression.list.GuardList;
import dybip.systemStmt.componentTypeStmt.InitTransitionStmt;

public class InitTransition extends DyBIPObject{
	State startState;
	GuardActionPair guardAction;
	
	public InitTransition(State startState, GuardActionPair guardAction){
		this.startState = startState;
		this.guardAction = guardAction;
	}
	public InitTransition(InitTransitionStmt initTransStmt){
		this(new State(initTransStmt.getStartState()), initTransStmt.getGuardActionPair());
	}
	public State getStartState(){
		return startState;
	}
	public GuardList getGuardList(){
		return guardAction.getGuard();
	}
	public ActionList getActionList(){
		return guardAction.getAction();
	}
	public String toString(int toStringMode){
		return "";
	}
	public String toString(){
		return "\t\tinitial to " + startState.toString() + " " + guardAction.toString();
	}
}
