package dybip.expression.action;

import dybip.Context;
import dybip.componentInstance.ComponentInstance;
import dybip.componentType.ComponentType;
import dybip.expression.Expression;
import dybip.expression.literal.BooleanLiteral;
import dybip.expression.variable.VariableExpression;
import dybip.motifInstance.Group;
import dybip.motifInstance.MotifContext;
import dybip.motifInstance.MotifInstance;
import dybip.motifType.MotifType;
import dybip.system.SystemContext;

public class CreateAction extends BinaryActionExpression{
	public CreateAction(Expression expr1, Expression expr2){
		super(expr1, expr2);
	}
	@Override
	public Expression minify(Context context) {				
		if(expr2 instanceof VariableExpression && expr1 instanceof  VariableExpression)
		{
			Expression type = expr1.minify(context);
			String variableName = ((VariableExpression) expr2).getVariableName();
			Group group = new Group(1, variableName);	

			// TODO check component type exists
						
			if(type instanceof ComponentType) {
				ComponentInstance newInstance = new ComponentInstance((ComponentType) type, context);
				group.add(newInstance);
				
				// update context to include new group
				((MotifContext) context).addGroup(group);
				return new BooleanLiteral(true);
			}
			else if(type instanceof MotifType) {
				SystemContext sysContext = (SystemContext) context;
				MotifInstance minstance = new MotifInstance( (MotifType) type, sysContext.getComponentTypeMap(), sysContext.getDataMap());
				// update context to include new motif
				sysContext.addMotif(minstance);
				context.addMotifToCurrentScope(variableName, minstance);
				context.putIndex(variableName, 0);
				return new BooleanLiteral(true);
			}
			
		}
		return new BooleanLiteral(false);
	}
	public String toString(){ 
		return "create(" + expr1.toString() + ", " + expr2.toString()  +")"; 
	}
	public String toString(int toStringMode){
		return "";
	}
	@Override
	public String toMinifyString(Context context) {
		return toString();
	}
}
