package dybip.expression.action;

import dybip.Context;
import dybip.componentInstance.ComponentInstance;
import dybip.expression.Expression;
import dybip.expression.literal.BooleanLiteral;
import dybip.motifInstance.Group;

public class JoinAction extends BinaryActionExpression{
	public JoinAction(Expression expr1, Expression expr2){
		super(expr1, expr2);
	}
	public Expression minify(Context context) {
		// a single element joins
		// a sub group elements join
		// a gorup joins another group

		// TODO only elements of same type can join a group
		Expression e1Minify = expr1.minify(context);
		Expression e2Minify = expr2.minify(context);
		
		if(e1Minify instanceof Group && e2Minify instanceof Group) {
			Group group1 = (Group) e1Minify;
			Group group2 = (Group) e2Minify;

			for(int i = 0; i < group1.size(); i++) {
				ComponentInstance instance = group1.get(i);
				if(!instance.getGroupPtrList().contains(group2))
				{	group2.add(instance);
					// update list of groups component is involved in 
					instance.addGroup(group2);
				}
			}
			return new BooleanLiteral(true);
		}
		return new BooleanLiteral(false);

	}
	public String toString(){ 
		return "join(" + expr1.toString() + ", " + expr2.toString()  +")"; 
	}
	public String toString(int toStringMode){
		return "";
	}
	@Override 
	public String toMinifyString(Context context){
		return "join(" + expr1.toMinifyString(context) + ", " + expr2.toMinifyString(context)  +")"; 
	}
}
