package dybip.expression.action;

import dybip.Context;
import dybip.componentInstance.ComponentInstance;
import dybip.expression.Expression;
import dybip.expression.literal.BooleanLiteral;
import dybip.motifInstance.Group;


public class LeaveAction extends BinaryActionExpression{
	public LeaveAction(Expression e1, Expression e2){
		super(e1, e2);
	}
	@Override
	public Expression minify(Context context) {
		Expression e1Minify = expr1.minify(context);
		Expression e2Minify = expr2.minify(context);
		
		if(e1Minify instanceof Group && e2Minify instanceof Group) {
			Group group1 = (Group) e1Minify;
			Group group2 = (Group) e2Minify;
			
			// update group ptr list in all instances
			for(int i = 0; i < group1.size(); i++)
			{
				ComponentInstance cInstance = group1.get(i);
				if(group2.contains(cInstance)) {
					cInstance.removeGroup(group2);
				}
				else {
					System.err.println(toString() + "instance doesnt belong to group");
					return new BooleanLiteral(false);
				}
			}
			group2.removeAll(group1);
			return new BooleanLiteral(true);
			
		}
		return new BooleanLiteral(false);
	}
	public String toString(){ 
		return "leave(" + expr1.toString() + ", " + expr2.toString()  +")"; 
	}
	public String toString(int toStringMode){
		return "";
	}
	@Override
	public String toMinifyString(Context context) {
		return "leave(" + expr1.toMinifyString(context) + ", " + expr2.toMinifyString(context)  +")"; 
	}
}
