package dybip.expression.booleanExpr;

import dybip.expression.Expression;
import dybip.expression.literal.BooleanLiteral;
import dybip.Context;

public class And extends BinaryBooleanExpression{
	
	public And(Expression e1, Expression e2){
		super(e1, e2);
	}
	@Override
	public String toString(){
		return expr1.toString() + " & " + expr2.toString();
	}
	@Override
	public Expression minify(Context context){
		
		// left hand side
		Expression lhs = expr1.minify(context);
		Class<?> c1 = lhs.getExpressionType(context);
		
		if(c1 == Boolean.class && lhs.value(Boolean.class) == false)
			return new BooleanLiteral(false);
					
					
		// right hand side
		Expression rhs = expr2.minify(context);
		Class<?> c2 = rhs.getExpressionType(context);
		
		if(c1 == Boolean.class && c2 == Boolean.class){
			Boolean and = lhs.value(Boolean.class) & rhs.value(Boolean.class);
			return new BooleanLiteral(and);
		}
		else
		{
			//ERROR cant apply or on non boolean expressions
			return null;
		}
			
	}
}
