package dybip.expression.booleanExpr;

import dybip.expression.Expression;
import dybip.expression.literal.BooleanLiteral;
import dybip.Context;

public class Inequality extends BinaryBooleanExpression{
	String operator;
	public Inequality(Expression e1, String operator,  Expression e2) {
		super(e1, e2);
		this.operator = operator;
	}
	@Override
	public String toString(){
		return expr1.toString() + " " + operator + " " + expr2.toString();
	}
	@Override
	public String toMinifyString(Context context){
		return expr1.toMinifyString(context) + " " + operator + " " + expr2.toMinifyString(context);
	}
	public Expression minify(Context context){
		Expression e1 = (expr1.minify(context));
		Expression e2 = (expr2.minify(context));
		
		Class<?> c1 = e1.getExpressionType(context);
		Class<?> c2 = e2.getExpressionType(context);
		
		// ERROR operation on 
		if(c1 == Integer.class && c2 == Integer.class)
		{
			int i1 = e1.value(Integer.class);
			int i2 = e2.value(Integer.class); 
		
			switch (operator){
				case "<": return new BooleanLiteral(i1 < i2);
				case "<=": return new BooleanLiteral(i1 <= i2);
				case ">": return new BooleanLiteral(i1 > i2);
				case ">=": return new BooleanLiteral(i1 >= i2);
			}
		}
		return new BooleanLiteral(false);
	}
}
