package dybip.expression.booleanExpr;

import dybip.expression.Expression;
import dybip.expression.literal.BooleanLiteral;
import dybip.Context;

public class Negation extends BooleanExpression{
	private Expression expr;
	public Negation(Expression expr){
		this.expr = expr;
	}
	@Override
	public Expression minify(Context context) {
		Expression e = expr.minify(context);
		Class<?> c1 = e.getExpressionType(context);
		if (c1 == Boolean.class){
			return new BooleanLiteral(!e.value(Boolean.class));
		}
		else{
			System.err.println("Cant negate a non boolean expression: " + expr);
			System.exit(0); return new BooleanLiteral(false); 
		}
	}
	@Override
	public String toString() {
		return "not(" + expr.toString() + ")";
	}
	@Override
	public String toMinifyString(Context context) {
		return "not(" + expr.toMinifyString(context) + ")";
	}
	@Override
	public Class<?> getExpressionType(Context context) {
		return Boolean.class ;
	}
	
	
}
