package dybip.expression.booleanExpr;

import dybip.expression.Expression;
import dybip.expression.literal.BooleanLiteral;
import dybip.motifInstance.Group;
import dybip.Context;

public class SetInclusion extends BinaryBooleanExpression {
	
	public SetInclusion(Expression e1, Expression e2){
		super((e1), e2);
	}
	@Override
	public String toString(){
		return expr1.toString() + " in " + expr2.toString();
	}
	@Override
	public String toMinifyString(Context context){
		return expr1.toMinifyString(context) + " in " + expr2.toMinifyString(context);
	}
	@Override
	public Expression minify(Context context){
		// ERROR incompatible types 
//		// TODO hardcoded 1 type of expression update to any expression 
		
		Expression minified1 = expr1.minify(context);
		Expression minified2 = expr2.minify(context);
		
		
		if(minified1 instanceof Group && minified2 instanceof Group) {
			Group group1 = (Group)minified1;
			Group group2 = (Group)minified2;
			for(int i = 0; i < group1.size(); i++)
			{
				if (!group2.contains(group1.get(i)))
					return new BooleanLiteral(false);
			}
			return new BooleanLiteral(true);
		}
//		if(expr1 instanceof UnaryArrayAccess && expr2 instanceof VariableExpression){
//			ComponentArrayInstance elem = (ComponentArrayInstance) expr1.minify(context);		
//			ComponentArrayInstance set = (ComponentArrayInstance) expr2.minify(context);
//			
//			if(elem != null && set != null){
//				for(int i = 0; i < elem.size(); i++)
//					if(!set.contains(elem.get(i)))
//						return new BooleanLiteral(false);
//					return new BooleanLiteral(true);
//			}
//			return new BooleanLiteral(false);
//		}
		return new BooleanLiteral(false);
	}
	@Override
	public Class<?> getExpressionType(Context context){
		return boolean.class;
	}
}
