package dybip.expression.list;

import dybip.componentInstance.Data;
import dybip.expression.Expression;
import dybip.expression.literal.NullLiteral;
import dybip.Context;

/**
 * 
 * @author el-ballouli
 * @version 1.0
 * 
 * This class is representation of a list of component data variables. This class is used when accessing data from a component array instance all data is grouped into a list 
 * 
 */
public class DataList extends ExpressionList<Data>{
	
	/**
	 * @param size of the data list
	 * @return a datalist of size
	 */
	public DataList(int size){
		super(size);
	}
	public DataList(){
		super();
	}
	public void setData(Expression value) {
		for(int i = 0; i < size(); i++)
			get(i).setData(value);
	}
	@Override 
	public Expression minify(Context context) {
		return null;
	}
	/**
	 * 
	 */
	@Override
	public Class<?> getExpressionType(Context context) {
		return get(0).getExpressionType(context);
	}
	@Override
	public <T>T value(Class<T> type){
		return get(0).value(type);
	}
	/**
	 * 
	 */
	public Class<?> getListType(Context context){
		// ASSUMPTION a data list contains one type of data
		if(size() > 0)
			if(get(0) != null)
				return get(0).getExpressionType(context);
		return NullLiteral.class; //ERROR empty data
	}
}
