package dybip.expression.literal;

import dybip.expression.Expression;
import dybip.expression.booleanExpr.BooleanExpression;
import dybip.Context;

public class BooleanLiteral extends BooleanExpression {
	Boolean bool;
	
	public BooleanLiteral(String value){
		super();
		bool = new Boolean(value);
	}
	public BooleanLiteral(boolean b){
		super();
		bool = new Boolean(b);
	}
	@Override
	public String toString() {
		return bool + "";
	}
	@Override
	public String toMinifyString(Context context) {
		return toString();
	}
	@Override
	public Expression minify(Context context) {
		return this;
	}
	@Override
	public Class<?> getExpressionType(Context context){
		return Boolean.class;
	}
	@Override
	public  <T> T  value( Class<T> type){
		return type.cast(bool);
	}
}
