package dybip.expression.literal;


import dybip.expression.Expression;
import dybip.Context;

public class DecimalLiteral extends LiteralExpression{
	private Double number;

	public DecimalLiteral(String value){
		number = new Double(value);
	}
	public DecimalLiteral(double value){
		number = new Double(value);
	}
	@Override
	public String toString() {
		return number + "";
	}
	@Override
	public String toMinifyString(Context context) {
		return toString();
	}
	@Override
	public Expression minify(Context context) {
		return this;
	}
	@Override
	public Class<?> getExpressionType(Context context){
		return Double.class;
	}
	@Override
	public  <T> T  value( Class<T> type){
		return type.cast(number);
	}
}
