package dybip.expression.literal;

import dybip.expression.Expression;
import dybip.Context;

public class IntegerLiteral extends LiteralExpression{
	private Integer number;

	public IntegerLiteral(String value){
		number = new Integer(value);
	}
	public IntegerLiteral(int value){
		number = new Integer(value);
	}
	public IntegerLiteral(double value) {
		number = new Integer((int) value);
	}
	@Override
	public String toString() {
		return number + "";
	}
	@Override
	public String toMinifyString(Context context) {
		return toString();
	}
	@Override
	public Expression minify(Context context) {
		return this;
	}
	@Override
	public Class<?> getExpressionType(Context context){
		return Integer.class;
	}
	@Override
	public  <T> T  value( Class<T> type){
		return type.cast(number);
	}
}
