package dybip.expression.variable;

import dybip.componentInstance.ComponentInstance;
import dybip.expression.Expression;
import dybip.Context;
import dybip.motifInstance.Group;
public class GroupAccess extends VariableExpression{
	Expression indexExpr;

	public GroupAccess(String varName, Expression expr) {
		super(varName);
		indexExpr = expr;
	}
	
	@Override
	public Expression minify(Context context){
		Expression expr = super.minify(context);
		if(expr instanceof Group){
			Group group = (Group) expr;
			Integer index = context.getIndex(indexExpr);
			if(index >  group.size() || index < 0 ){// ERROR index out of bound
				System.err.println("INDEX OUT OF BOUND"); System.exit(0);}
			else{
				ComponentInstance ci = group.get(index);
				Group newGroup = new Group(1, group.getName()); // TODO: what to name group?
				newGroup.add(ci);
				return newGroup;
			}
		}
		else
		{	// ERROR
			System.err.println( str + "Acessing a non group"); System.exit(0);}
		return null; // ERROR reference non existing variable or not a component	
	}

	public String getVariableName(){
		return str;
	}
	public Expression getIndexExpr(){
		return indexExpr;
	}
	@Override
	public Class<?> getExpressionType(Context context) {
		return Group.class;
	}
	@Override
	public String toString(){
		return str + "[" + indexExpr.toString() + "]";
	}
	@Override
	public String toMinifyString(Context context){
		return str + "[" + indexExpr.toMinifyString(context) + "]";
	}	
	
	
	

}
