package dybip.expression.variable;

import dybip.Context;
import dybip.componentInstance.ComponentInstance;
import dybip.expression.Expression;
import dybip.expression.literal.IntegerLiteral;
import dybip.motifInstance.Group;

public class IndexOfExpression extends Expression{
	private VariableList vlistComponent;
	private VariableList vlistGroup;
	
	public IndexOfExpression(VariableList vlistComponent, VariableList vlistGroup) {
		this.vlistComponent = vlistComponent;
		this.vlistGroup = vlistGroup;
	}
	@Override
	public Expression minify(Context context) {
		Expression expr = vlistComponent.minify(context);
		Expression expr2 = vlistGroup.minify(context);
		if(expr instanceof ComponentInstance & expr2 instanceof Group){
			Group group = (Group)expr;
			ComponentInstance cinstance = (ComponentInstance) expr2;
			
			int index = group.indexOf(cinstance);
			return new IntegerLiteral(index);
		}
		return new IntegerLiteral(-1);
	}
	@Override
	public String toString(){
		return vlistComponent.toString() + ".indexOf(" + vlistGroup.toString() + ")";
	}
	@Override
	public String toString(int toStringMode){
		return vlistComponent.toString(toStringMode) + ".indexOf(" + vlistGroup.toString(toStringMode) + ")";
	}
	@Override
	public Class<?> getExpressionType(Context context) {
		// TODO Auto-generated method stub
		return null;
	}
	@Override
	public String toMinifyString(Context context) {
		// TODO Auto-generated method stub
		return null;
	}
}
