package dybip.expression.variable;

import dybip.Context;
import dybip.expression.Expression;
import dybip.expression.literal.BooleanLiteral;
import dybip.motifInstance.Group;

public class PortAccess extends Expression{
	private String portName;
	private VariableList variableList;
	public PortAccess(int size, String portName){
		variableList = new VariableList(size);
		this.portName = portName;
	}
	public void add(VariableExpression elem){
		variableList.add(elem);
	}
	public String getPortName(){
		return portName;
	}
	public VariableList getVariableList(){
		return variableList;
	}
	@Override
	public Expression minify(Context context) {
		Expression expr = variableList.minify(context);
		Boolean enabledPorts = true;
		if(expr instanceof Group && ((Group) expr).size() != 0)
		{
			Group group = (Group) expr;
			for(int i = 0; i < group.size(); i++)
				enabledPorts = enabledPorts & group.get(i).getEnabledPort().contains(portName);
			return new BooleanLiteral(enabledPorts);
		}
		return new BooleanLiteral(false);
	}
	
	@Override
	public Class<?> getExpressionType(Context context) {
		// TODO Auto-generated method stub
		return null;
	}
	@Override
	public String toMinifyString(Context context) {
		// TODO Auto-generated method stub
		return null;
	}
	
	@Override
	public String toString(){
		return variableList.toString() + "." + portName;
	}
	@Override
	public String toString(int toStringMode){
		return variableList.toString(toStringMode) + "." + portName;
	}
}
