package dybip.expression.variable;

import dybip.Context;
import dybip.expression.Expression;
import dybip.expression.literal.IntegerLiteral;
import dybip.motifInstance.Group;

public class SizeExpression extends Expression{
	private VariableList variableList;
	public SizeExpression(int size){
		variableList = new VariableList(size);
	}
	public SizeExpression(){
		variableList = new VariableList();
	}
	public void add(VariableExpression elem){
		variableList.add(elem);
	}
	@Override
	public Expression minify(Context context) {
		Expression expr = variableList.minify(context);
		
		if(expr instanceof Group){
			IntegerLiteral size = new IntegerLiteral(((Group) expr).size());
			return size;
		}
		return new IntegerLiteral(-1); // returns -1 if not a group
	}
	@Override
	public String toString(){
		return variableList.toString() + ".size";
	}
	@Override
	public String toString(int toStringMode){
		return super.toString(toStringMode) + ".size";
	}
	@Override
	public Class<?> getExpressionType(Context context) {
		// TODO Auto-generated method stub
		return null;
	}
	@Override
	public String toMinifyString(Context context) {
		// TODO Auto-generated method stub
		return null;
	}
}
