package dybip.expression.variable;

import dybip.componentInstance.ComponentInstance;
import dybip.expression.Expression;
import dybip.motifInstance.Group;
import dybip.Context;

public class SubGroupAccess extends VariableExpression{

	Expression indexBeginExpr;
	Expression indexEndExpr;

	public SubGroupAccess(String varName, Expression exprBegin, Expression exprEnd) {
		super(varName);
		indexBeginExpr = exprBegin;
		indexEndExpr = exprEnd;
	}
	public String getVariableName(){
		return str;
	}
	public Expression getBeginIndexExpr() {
		return indexBeginExpr;
	}
	public Expression getEndIndexExpr() {
		return indexEndExpr;
	}
	@Override
	public Expression minify(Context context){
		Expression expr = super.minify(context);
		if(expr instanceof Group){
			Group group = (Group) expr;
			Integer startIndex = context.getIndex(indexBeginExpr);;
			Integer endIndex = context.getIndex(indexEndExpr);
			
			if(endIndex >  group.size() || startIndex < 0 ){
				System.err.println("INDEX OUT OF BOUND"); System.exit(0);}
			else{
				
				Group newGroup = new Group(endIndex - startIndex + 1, group.getName()); // TODO: what to name group?
				for(int i = startIndex; i < endIndex; i++){
					ComponentInstance ci = group.get(i);
					newGroup.add(ci);
				}
				return newGroup;
			}
		}
		else
		{	// ERROR
			System.err.println( str + "Acessing a non group"); System.exit(0);}
		return null; // ERROR reference non existing variable or not a component	
	}
//	@Override
//	public Expression minify(Context context){
//		Expression indexBeginExpression = indexBeginExpr.minify(context);
//		Expression indexEndExpression = indexEndExpr.minify(context);
//		Integer index = null;
//		if(indexExpression instanceof DataList ){
//			DataList dlist = (DataList) indexExpression;
//			if(dlist.getListType(context) == Integer.class)
//			{
//				if(dlist.size() == 1)
//					index = dlist.get(0).minify(context).value(Integer.class);
//				else ;
//					// TODO multiple array aceess;	
//			}
//			else
//				;
//				//ERROR cant have a noninteger index
//		}
//		else
//			index = indexExpression.value(Integer.class);
//		Expression variable =  null;
////				context.find(str);
//		
//		if(variable instanceof ComponentArrayInstance){
//			ComponentArrayInstance cInstanceList = ((ComponentArrayInstance) variable);
//			ComponentArrayInstance carray = new ComponentArrayInstance(cInstanceList.getstr(), 1);
//			if(index >  cInstanceList.size() || index < 0 );
//				// ERROR index out of bound
//			carray.add(cInstanceList.get(index));
//			return carray;
//		}
//		else 
//			return null; // ERROR reference non existing variable or not a component	
//	}
	
	@Override
	public Class<?> getExpressionType(Context context) {
		return ComponentInstance.class;
	}
	@Override
	public String toString(){
		return str + "[" + indexBeginExpr.toString() + ":" + indexEndExpr.toString() + "]";
	}
	@Override
	public String toMinifyString(Context context){
		return str + "[" + indexBeginExpr.toMinifyString(context) + ":" +  indexEndExpr.toMinifyString(context) + "]";
	}	
		
	
}
