package dybip.motifInstance;

import java.util.HashSet;
import java.util.Set;

import dybip.Context;
import dybip.componentInstance.ComponentInstance;
import dybip.expression.Expression;
import dybip.expression.list.ExpressionList;

public class Group extends ExpressionList<ComponentInstance>{
	private String groupName;
	public Group(int size, String groupName){
		super(size);
		this.groupName = groupName;
	}
	public void remove(ComponentInstance instance) {
		int index = indexOf(instance);
		remove(index);
	}
	public Set<Integer> getIds(){
		Set<Integer> ids = new HashSet<Integer>();
		
		for(int i = 0; i < size(); i++)
			ids.add((int)(long)get(i).getID());
		return ids;
	}
	@Override 
	public Expression minify(Context context) {
		return null;
	}
	@Override
	public Class<?> getExpressionType(Context context){
		return Group.class;
	}
	public String getName(){
		return groupName;
	}
	public Group(){
		super();
	}
	public String getTrace() {
		String trace = "";
		for(int i = 0; i < size(); i++) {
			trace += get(i).getTrace();
		}
		return trace;
	}
	public String tString(){
		return groupName;
	}
}
