package dybip.motifType;

import dybip.Context;
import dybip.InteractionStmt.InteractionRuleStmtList;
import dybip.InteractionStmt.ReconfigurationRuleStmtList;
import dybip.expression.Expression;
import dybip.systemStmt.motifTypeStmt.ComponentInstanceStmtList;
import dybip.systemStmt.motifTypeStmt.MotifTypeStmt;
import dybip.systemStmt.motifTypeStmt.ReferStmtList;


public class MotifType extends Expression{
	private String name;
	private ReferStmtList referals;
	private ComponentInstanceStmtList instances;
	private ReconfigurationRuleStmtList reconfigRuleList;
	private InteractionRuleStmtList interactionRuleList;

	public MotifType(MotifTypeStmt stmt){
		this(stmt.getName(),
					stmt.getReferStmtList(),
					stmt.getComponentInstanceStmtList(),
					stmt.getReconfigRuleStmtList(),
					stmt.getInteractionRuleStmtList());	
	}
	public MotifType(String name, ReferStmtList referals, ComponentInstanceStmtList instancesList, ReconfigurationRuleStmtList reconfigRuleList, InteractionRuleStmtList interactionRuleList){
		this.name = name;
		this.referals = referals;
		this.instances = instancesList;
		this.reconfigRuleList = reconfigRuleList;
		this.interactionRuleList = interactionRuleList;
	}
	public String getName(){
		return name;
	}
	public ReferStmtList getReferStmtList() {
		return referals;
	}
	public ComponentInstanceStmtList getComponentInstanceStmtList() {
		return instances;
	}
	public ReconfigurationRuleStmtList getReconfigurationRuleStmtList() {
		return reconfigRuleList;
	}
	public InteractionRuleStmtList getInteractionRuleStmtList() {
		return interactionRuleList;
	}
	public String toString(){
		String  str =  name + "\t{" ;
		if(!referals.toString2().equals(""))
				return str + referals.toString2() + ","  + instances.toString2() + "}\n" ;
		else 
			return str + instances.toString2() + "}\n" ;
	}
	@Override
	public Expression minify(Context context) {
		return this;
	}
	@Override
	public Class<?> getExpressionType(Context context) {
		
		return MotifType.class;
	}
	@Override
	public String toMinifyString(Context context) {
		return name;
	}
}
