package dybip.motifType;

import dybip.DyBIPHashMap;
import dybip.InteractionStmt.InteractionRuleStmtList;
import dybip.InteractionStmt.ReconfigurationRuleStmtList;
import dybip.systemStmt.motifTypeStmt.ComponentInstanceStmtList;
import dybip.systemStmt.motifTypeStmt.MotifTypeStmt;
import dybip.systemStmt.motifTypeStmt.MotifTypeStmtList;
import dybip.systemStmt.motifTypeStmt.ReferStmtList;

public class MotifTypeMap extends DyBIPHashMap<String, MotifType>{

	public MotifTypeMap(int size){
		super(size);
	}
	public MotifTypeMap(){
		super();
	}
	public MotifTypeMap(MotifTypeStmtList list){
		super(list.size());
		for(int i = 0; i < list.size(); i++){
			MotifTypeStmt stmt = list.get(i);
			String name = stmt.getName();
			ReferStmtList referList = stmt.getReferStmtList();
			ComponentInstanceStmtList cInstance = stmt.getComponentInstanceStmtList();
			ReconfigurationRuleStmtList reconfigList = stmt.getReconfigRuleStmtList();
			InteractionRuleStmtList interactionList = stmt.getInteractionRuleStmtList();
			
			
			DynamicMotifTypeGenerator.generate(stmt.getName());
			MotifType mtype = DynamicMotifTypeGenerator.createMotifType(name, referList, cInstance, reconfigList, interactionList);
			put(mtype);
		}
	}
	public void put(MotifType type){
		put(type.getName(), type);
	}
	public String toString(){
		String str = "";
		for(String key : keySet())
			str += "\t\t" + get(key).toString() + "\n";
			
		return str;
	}
}
