package dybip.systemStmt;

import dybip.DyBIPObject;
import dybip.InteractionStmt.InterReconfigurationRuleStmtList;
import dybip.systemStmt.componentTypeStmt.*;
import dybip.systemStmt.motifInstanceStmt.MotifInstanceStmtList;
import dybip.systemStmt.motifTypeStmt.MotifTypeStmtList;

public class SystemStmt extends DyBIPObject {
	private String name;
	private ComponentTypeStmtList cTypeList;
	private MotifTypeStmtList motifTypeList;
	private InterReconfigurationRuleStmtList interReconfigRules;
	private MotifInstanceStmtList motifInstanceList;
	
	public SystemStmt(String name, ComponentTypeStmtList ctList, MotifTypeStmtList mtList, InterReconfigurationRuleStmtList interReconfigRuleList, MotifInstanceStmtList motifInstanceList)
	{
		this.name = name;
		this.cTypeList  = ctList;
		this.motifTypeList = mtList;
		this.interReconfigRules = interReconfigRuleList;
		this.motifInstanceList = motifInstanceList;
	}
	public ComponentTypeStmtList getComponentTypeStmtList(){
		return cTypeList;
	}
	public MotifTypeStmtList getMotifTypeStmtList(){
		return motifTypeList;
	}
	public MotifInstanceStmtList getMotifInstanceStmtList(){
		return motifInstanceList;
	}
	public InterReconfigurationRuleStmtList  getInterReconfigurationRuleStmtList(){
		return interReconfigRules;
	}
	public String toString(){
		return "system " + name + "\n" + 
					cTypeList.toString() + 
					motifTypeList.toString() + 
					interReconfigRules.toString() + 
					motifInstanceList.toString() + "\nend";
	}
}
