package dybip.systemStmt.componentTypeStmt;

import dybip.DyBIPObject;

/**
 * This class represents a Port in a component type. Ports are used to transition from one state to another in an automata. A port is identified by its name.
 * @author el-ballouli
 *
 */
public class PortStmt extends DyBIPObject {
	String name;
	
	/**
	 * Construct a port having the name specified in the parameter
	 * @param name
	 */
	public PortStmt(String name){
		this.name = name;
	}
	/**
	 * @return Returns the name of the port
	 */
	public String getName(){
		return name;
	}
	
	/**
	 * @return Returns name of the port regardless of to String mode specified in the parameter
	 */
	public String toString(int toStringMode){
		return name;
	}
	/**
	 * @return Returns name of the port
	 */
	public String toString(){
		return name;
	}
}
