package dybip.systemStmt.componentTypeStmt;

import dybip.DyBIPObject;

/**
 * This class represents a state in an automata.
 * A state is identified by its name. 
 * @author el-ballouli
 *
 */

public class StateStmt extends DyBIPObject{
	private String stateName;
	
	/**
	 * Constructs a new state having the name specified in the parameter as its name.
	 * @param name
	 */
	public StateStmt(String name){
		stateName = name;
	}
	/**
	 * This method is used to return the name of the state.
	 * @return String the name of state
	 */
	public String getName(){
		return stateName;
	}
	/**
	 * This method returns a string representation of the state class depending on the toStringmode specified in the parameter.
	 * Three different modes of toString are possible VERBOSE, DEBUG, NORMAL.\
	 * @return An empty string in all different toString modes
	 * @see  dybip.DyBIPRunner
	 */
	public String toString(int toStringMode){
		return "";
	}
	/**
	 * This method returns a string representation of the state class.
	 * @return The name of the state as a String
	 */
	public String toString(){
		return stateName;
	}
}
