package miscellaneous;

import java.awt.*;
import java.io.File;
import java.io.FileNotFoundException;
import java.util.ArrayList;
import java.util.Scanner;

import javax.swing.JApplet;

public class CollaboratingRobotSimulation extends JApplet {

	Graphics bufferGraphics; 
	Image offscreen; 

	int arenaX = 1000;
	int arenaY = 500;
	int RMIN = 0;

	ArrayList<Point[]> robots = new ArrayList<Point []>();
	Point nest; 
	Point prey; 
	//	Point robot;

	int iteration = 0;
	public void init() {
		scanFile("/home/el-ballouli/git/DR-BIP/tool/examples/statistics/size_collaboratingRobots_s6200_r1_PP_NN_RR_A1_P1 + 0_R5 + 100_RMAX200 + 0_RMIN150 + 0_N1 + 0.txt");
		//		robot = new Point((int)(Math.random()*arenaX) + 20 ,(int)(Math.random()*arenaY)+ 20);

		setBackground(Color.WHITE);
		setSize(1200, 700);
		offscreen = createImage(getWidth()+200,getHeight()+200); 
		bufferGraphics = offscreen.getGraphics(); 
	}

	private void scanFile(String file) {

		try {
			Scanner scanner = new Scanner(new File(file));

			for(int i = 0; i < 8; i++)
				scanner.nextLine();

			String robotCountStr = scanner.nextLine();
			Scanner lineScan = new Scanner(robotCountStr);
			lineScan.next(); int robotCount = lineScan.nextInt();
			lineScan.close();

			scanner.nextLine(); // skip

			String RMINstr = scanner.nextLine();
			lineScan = new Scanner(RMINstr);
			lineScan.next(); RMIN = lineScan.nextInt();
			lineScan.close();

			System.err.println(RMIN);
			for(int i = 0; i < 2+1+robotCount-1; i++)
				scanner.nextLine();


			String [] line = scanner.nextLine().split("\t");
			int x = Integer.parseInt(line[0].substring(0, line[0].indexOf(",")));
			int y = Integer.parseInt(line[0].substring(line[0].indexOf(",")+1));
			nest = new Point(x, y);

			x = Integer.parseInt(line[1].substring(0, line[1].indexOf(",")));
			y = Integer.parseInt(line[1].substring(line[1].indexOf(",")+1));
			prey = new Point(x, y);

			Point [] robotPoints = new Point [robotCount];
			for(int i = 2; i < line.length; i++ ) {
				x = Integer.parseInt(line[i].substring(0, line[i].indexOf(",")));
				y = Integer.parseInt(line[i].substring(line[i].indexOf(",")+1));
				System.out.println(x +  " " + y);
				Point p = new Point(x, y);
				robotPoints[i-2] = p;
			}
			robots.add(robotPoints);

			while(scanner.hasNextLine()) {
				line = scanner.nextLine().split("\t");
				robotPoints = new Point [robotCount];
				for(int i = 2; i < line.length; i++ ) {
					x = Integer.parseInt(line[i].substring(0, line[i].indexOf(",")));
					y = Integer.parseInt(line[i].substring(line[i].indexOf(",")+1));
					Point p = new Point(x, y);
					robotPoints[i-2] = p;
				}
				robots.add(robotPoints);
			}
			scanner.close();
		} catch (FileNotFoundException e) {
			e.printStackTrace();
		}

	}
	public void paint(Graphics g) {
		Dimension d = getSize();
		bufferGraphics.setColor(Color.WHITE);
		bufferGraphics.fillRect(0, 0, d.width, d.height);
		drawCenteredCircle(Color.RED, bufferGraphics, nest.x, nest.y, 10);
		drawCenteredCircle(Color.GREEN, bufferGraphics, prey.x, prey.y, 10);
		if(iteration < robots.size() - 10) {
			Point [] pp = robots.get(iteration+=10);
			for(int i = 0; i < pp.length; i++) {
				drawCenteredCircle(Color.blue, bufferGraphics, pp[i].x, pp[i].y ,10);
			}
		}
		try {
			Thread.sleep(100);
		}
		catch(InterruptedException ex) {}
		g.drawImage(offscreen, 0, 0, this);
//		clear(g);
		repaint();
	}
	public void clear(Graphics g) {
		if(iteration < robots.size()) {
			Point [] pp = robots.get(iteration-1);
			for(int i = 0; i < pp.length; i++) {
				drawCenteredCircle(Color.WHITE, g, pp[i].x, pp[i].y ,10);
			}
		}
	}
	public void drawCenteredCircle(Color c, Graphics g, int x, int y, int r) {
		g.setColor(c);
		x = x-(r/2);
		y = y-(r/2);
		g.fillOval(x,y,r,r);

		x = x-(RMIN/2);
		y = y-(RMIN/2);
		g.drawOval(x, y, RMIN, RMIN);
	}

	public void update1() {
		//		int xVector = nest.x - robot.x;
		//		int yVector =  nest.y - robot.y;
		//
		//		double vLength = Math.sqrt(Math.pow(xVector, 2) + Math.pow(yVector, 2));
		//
		//		double xvnorm = xVector/vLength;
		//		double yvnorm = yVector/vLength;
		//
		//		robot.setLocation(robot.x+xvnorm, robot.y+yvnorm);
	}
}