package miscellaneous;

import java.io.OutputStreamWriter;
import java.io.PrintStream;
import java.io.PrintWriter;
import java.io.UnsupportedEncodingException;

public class PrintColorWriter extends PrintWriter{

	private static final String ANSI_RESET = "\u001B[0m";
	private static final String separator = "------------------------------------";
	private static final int MAXPADDINGLENGTH = 25;
	
	public PrintColorWriter(PrintStream out) throws UnsupportedEncodingException {
		super(new OutputStreamWriter(out, "UTF-8"), true);
	}

	public void println(PrintColor color, String string) {
		print(color.getAnsiColor());
		print(string);
		println(ANSI_RESET);
		flush();
	}
	private static String getPadding(String str, int length){
		int strLength = str.length();
		int paddLength = length - strLength;
		String padd = "";
		for(int i = 0; i < paddLength/2 ; i++)
			padd += " ";
		return padd;
	}
	private static String getRightPadding(String str, int length){
		int strLength = str.length();
		int paddLength = length - strLength;
		if(paddLength % 2 == 0)
			return getPadding(str, length);
		else
			return " " + getPadding(str, length);
	}
	private String getFormatedseparatorStr(String str){
		return separator + getRightPadding(str, MAXPADDINGLENGTH) + str + getPadding(str, MAXPADDINGLENGTH)+ separator ;
	}
	public void printSeparatorln(String string){
		println(getFormatedseparatorStr(string));
	}
	public void printGreenSeparatorln(String string){
		printGreenln(getFormatedseparatorStr(string));
	}
	public void printRedSeparatorln(String string){
		printRedln(getFormatedseparatorStr(string));
	}
	public void printBlueSeparatorln(String string){
		printBlueln(getFormatedseparatorStr(string));
	}
	public void printCyanSeparatorln(String string){
		printCyanln(getFormatedseparatorStr(string));
	}
	public void printPurpleSeparatorln(String string){
		printPurpleln(getFormatedseparatorStr(string));
	}
	public void printYellowSeparatorln(String string){
		printYellowln(getFormatedseparatorStr(string));
	}
	
	
	public void printGreenln(String string) {
		println(PrintColor.GREEN, string);
	}
	public void printRedln(String string) {
		println(PrintColor.RED, string);
	}
	public void printBlueln(String string) {
		println(PrintColor.BLUE, string);
	}
	public void printCyanln(String string) {
		println(PrintColor.CYAN, string);
	}
	public void printPurpleln(String string) {
		println(PrintColor.PURPLE, string);
	}
	public void printYellowln(String string) {
		println(PrintColor.YELLOW, string);
	}
	
}